---
variables:
  DOCKER_IMAGE: not-set
  DOCKER_IMAGE_DIRECTORY: "."
  DOCKER_BUILD_TAG: $CI_COMMIT_REF_SLUG
  DOCKER_EXTRA_ARGS: ""

.docker:login:
  script:
    - echo "${CI_DEPENDENCY_PROXY_PASSWORD}" |
      docker login gitlab.com --username "${CI_DEPENDENCY_PROXY_USER}" --password-stdin
    - echo "${CI_REGISTRY_PASSWORD}" |
      docker login "${CI_REGISTRY}" --username "${CI_REGISTRY_USER}" --password-stdin

.docker:login-before-script:
  before_script:
    - !reference [.docker:login, script]

.docker:before-script:
  before_script:
    - !reference [.docker:login, script]
    - export IMAGE_NAME="${CI_REGISTRY_IMAGE}"
    - >
      if [[ "${DOCKER_IMAGE}" != "not-set" ]]; then
        export IMAGE_NAME="${IMAGE_NAME}/${DOCKER_IMAGE}"
      fi

.docker:on-change:
  rules:
    - if: $CI_COMMIT_BRANCH
      changes:
        - $DOCKER_IMAGE_DIRECTORY/*

.docker:dind:
  image: docker:20.10.8
  variables:
    DOCKER_TLS_CERTDIR: "/certs"
    DOCKER_BUILDKIT: "1"
  services:
    - docker:20.10.8-dind

.docker:build:
  stage: build
  extends:
    - .docker:dind
  interruptible: true
  script:
    - !reference [.docker:before-script, before_script]
    - echo "Building image '${IMAGE_NAME}:${DOCKER_BUILD_TAG}'"
    - docker build -t "${IMAGE_NAME}:${DOCKER_BUILD_TAG}"
        --build-arg "GITLAB_USER=gitlab-ci-token"
        --secret id=GITLAB_TOKEN,env=CI_JOB_TOKEN
        ${DOCKER_EXTRA_ARGS}
        "${DOCKER_IMAGE_DIRECTORY}"
    - docker push "${IMAGE_NAME}:${DOCKER_BUILD_TAG}"

.docker:release:
  stage: release
  extends:
    - .docker:dind
  script:
    - !reference [.docker:before-script, before_script]
    - >
      if [[ -n "${CI_COMMIT_TAG}" ]]; then
        RELEASE_TAG="${CI_COMMIT_TAG}"
      fi
    - export RELEASE_TAG="${RELEASE_TAG%%-*}"  # turns 1.2.3-infratools -> 1.2.3
    - docker pull "${IMAGE_NAME}:${DOCKER_BUILD_TAG}"
    - docker tag "${IMAGE_NAME}:${DOCKER_BUILD_TAG}" "${IMAGE_NAME}:${RELEASE_TAG}"
    - docker push "${IMAGE_NAME}:${RELEASE_TAG}"
    - docker tag "${IMAGE_NAME}:${DOCKER_BUILD_TAG}" "${IMAGE_NAME}:latest"
    - docker push "${IMAGE_NAME}:latest"
